<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' Merge Templates with Database
'*********************************************************************************

const pfieldnames=1
const pfieldvalues=2
const pfieldtypes=3
const pfieldcount=4
const ptableflag=5
const pTemplatedisplay=6
const pTemplaterray=7
const ptokenformat=8
const pIDField=9
const pidvalue=10
const ptokens=11
const pdatacurrentrecord=12
const pdata=13
const pdatarecordcount=14
const pdatainmemory=15
const pparseattributes=16

'filename to be opened
'rc=4 if file cannot be found
'returns fsObj and RecordObj
sub OpenInputFile (filename, fsObj, RecordObj, rc)
   '701 - 2010.12.21 - Bug Fix: Possible error while opening text file
   filename = replace(trim(filename),chr(13),"")

   if lcase(left(filename,10)) = "templates/" then filename = xmysite2 & "/" & filename
   on error resume next
   dim whichfile, dbfile, xtemplate, cmpstr1, cmpstr2, cmpstr3
   xtemplate = getconfig("xtemplate")
   cmpstr1 = lcase(filename)
   cmpstr2 = lcase(xmysite2 & "/templates/"& xtemplate &"/")
   dbfile=left(replace(cmpstr1,cmpstr2,""),3)
   if lcase(dbfile)="db=" then
      OpenInputFiledb replace(cmpstr1,cmpstr2,""), fsObj, RecordObj, rc
      exit sub
   end if
   
   dim dpos, dposstr
   dpos = instr(cmpstr1,"/" & "templates/")
   if dpos = 0 then dpos = instr(cmpstr1,"\" & "templates\")
   dposstr = mid(filename, dpos, len(filename) - dpos + 1)
   
   dim realfilename
   realfilename = lcase(dposstr)
   cmpstr2 = lcase("/" & "templates/" & xtemplate & "/")
   cmpstr3 = lcase("\" & "templates/" & xtemplate & "\")
   realfilename = replace(realfilename,cmpstr2,"")
   realfilename = replace(realfilename,cmpstr3,"")

   '700 - getting real subfolder name
   dim infolder
   infolder = server.mappath(filename)
   infolder = replace(lcase(infolder),lcase(dposstr),"")
   infolder = replace(lcase(infolder),replace(lcase(dposstr),"/","\"),"")

   whichfile=infolder & "\" & "templates\" & xtemplate & "\" & realfilename

   '700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
   if lcase(getconfig("xReadTextUTF8Filer")) = "yes" and instr(lcase(realfilename),".txt") > 0 then
      Set RecordObj = New UTF8Filer
      RecordObj.UnicodeCharset = "utf-8"
      RecordObj.LoadFile(whichfile)
      RecordObj.cTextBuffer2Unicode
	  session("fromutf8codepage") = "Yes"
   else
      set fsObj = Server.CreateObject("Scripting.FileSystemObject")
      set RecordObj= fsObj.OpenTextFile(whichfile, 1, False)
	  session("fromutf8codepage") = ""
   end if

   if err.number > 0 then
      rc=4

	  '700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
	  if lcase(session("fromutf8codepage")) <> "yes" then
         fsObj.close
         set fsObj=nothing
      else
	     set RecordObj = nothing
      end if

   else
      rc=0
   end if
end sub

'close a file
'700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
sub CloseFile (fsObj, RecordObj, rc, parsearray)
   if parsearray(pdatainmemory)="Yes" then exit sub

   if lcase(session("fromutf8codepage")) <> "yes" then
      set RecordObj = nothing
      set fsObj = nothing
   else
      set RecordObj = nothing
   end if
   rc=0
end sub

'reads and entire file Template into a memory array
'creates and array of converted records
sub ShopTemplateArray(Filename, RS, Outarray, Outcount)
dim parsearray, fieldnames, fieldvalues, fieldtypes, fieldcount

'6.50 - updated to 150 from 100
redim fieldnames(150)
redim fieldvalues(150)
redim fieldtypes(150)

redim parsearray(Pparseattributes)
dim i
dim NewRecord
dim fs,ts
dim rc
dim Bypass
dim tempcount

'700 moving to Template folder
dim xTemplate
dim tempfilename,tempfilename2
xTemplate= "Templates/" & GetConfig("xTemplate") & "/"
tempfilename=xTemplate & Filename
tempfilename2=Filename

OpenInputFile tempfilename, fs, ts, rc
if rc> 0 then
   ShopWriteError  GetLang("LangReadFail")  & tempfilename  
   exit sub
end if
GetFieldValues RS, fieldnames, fieldvalues, fieldtypes, fieldcount
dim Temparray
tempcount=ubound(outarray)
redim temparray(tempcount)
outcount=0
SetupParseArray Parsearray, tempfilename2, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fs, ts
ReadEntireFile fs, ts, Tempcount, TempArray, parsearray
CloseFile fs,ts, rc, parsearray
for i = 0 to tempcount - 1
   Substitute Temparray(i), NewRecord, Bypass, parsearray, rs
   if Bypass=False  then
      OutArray(outcount)=NewRecord
      outcount=outcount+1
   end if
next
end sub

sub SetupParseArray (Parsearray, filename, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fsoobj,recordobj)
dim data, datacount, rc, dbfieldname
redim parsearray(Pparseattributes)
parsearray(pfieldnames)=fieldnames
parsearray(pfieldvalues)=fieldvalues
parsearray(pfieldtypes)=fieldtypes
parsearray(pfieldcount)=fieldcount
parsearray(ptableflag)=""
parsearray(pTemplatedisplay)="No"
parsearray(pIDField)=rs(0).name
parsearray(pidvalue)=rs(0).value
parsearray(pdatarecordcount)=0
parsearray(pdatainmemory)=""
CheckFiledb filename,dbfieldname,rc
if rc=0 then
   redim data(500)
   ReadEntireFileDB  fsoobj, RecordObj, datacount,data,parsearray
   parsearray(pdata)=data
   parsearray(pdatarecordcount)=datacount
   parsearray(pdatacurrentrecord)=0
   parsearray(pdatainmemory)="Yes"
end if
end sub

'writes each record to browser
sub ShopTemplateWrite(Filename, RS, orc)
dim i
dim NewRecord
dim recordObj, FsObj
dim rc
dim MyText
dim readcount
dim Bypass

'700 moving to Template folder
dim xTemplate
dim tempfilename,tempfilename2
xTemplate= "Templates/" & GetConfig("xTemplate") & "/"
tempfilename=xTemplate & Filename
tempfilename2=Filename

OpenInputFile tempfilename, fsObj, RecordObj, rc
if rc> 0 then
   ShopWriteError  GetLang("LangReadFail")  & tempfilename
   orc=4
   exit sub
end if
dim parsearray, fieldnames, fieldvalues, fieldtypes, fieldcount
redim fieldnames(150)
redim fieldvalues(150)
redim fieldtypes(150)
redim parsearray(Pparseattributes)
readcount=0
GetFieldValues RS, fieldnames, fieldvalues, fieldtypes, fieldcount

SetupParseArray Parsearray, tempfilename2, rs, fieldnames, fieldvalues, fieldtypes, fieldcount, fsobj, recordobj
Parsearray(pTemplateDisplay)="Yes"
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   Substitute mytext, NewRecord, Bypass, parsearray, rs
   if Bypass=False  then
      response.write NewRecord & vbcrlf
   end if
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
CloseFile fsObj,RecordObj, rc, parsearray
orc=0
end sub

sub ReadEntireFile (fsoobj, RecordObj, readcount, readarray,parsearray)
dim rc
dim mytext, data, i
if parsearray(pdatainmemory)="Yes" then
   data=parsearray(Pdata)
   for i = 0 to parsearray(pdatarecordcount)-1
      readarray(i)=data(i)
   next
   readcount=parsearray(pdatarecordcount)
   exit sub
end if
rc=0
readcount=0
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   readarray(readcount)=mytext
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
end sub

'700 - 2010.05.13 - Enhancement: Import text file using UTF8Filer class
sub ReadARecord (RecordObj, record, rc,parsearray)
   if parsearray(Pdatainmemory)="Yes" then
      ReadARecordDB RecordObj, record, rc,parsearray
      exit sub
   end if

   if lcase(session("fromutf8codepage")) <> "yes" then
      if RecordObj.AtEndofStream then
         rc=4
         exit sub
      end if
   else
      if RecordObj.eof then
         rc = 4
         exit sub
      end if
   end if
   record = RecordObj.readline
   rc=0
end sub

function Find_Replace(srchString, FndString, InsertString,   strend )
dim i, LastChar, Next_Pos
dim CurrentPos, LastPos
dim tempstring

if strend > 0 then
   LastChar = strend
else
   LastChar = Len(srchString)
end if
tempstring = srchString
Next_Pos = 0
Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
do until (Next_Pos = 0) Or (Next_Pos > LastChar)
   tempstring = Left(tempstring, Next_Pos - 1) & InsertString & Right(tempstring, (Len(tempstring) - Len(FndString) - (Next_Pos - 1)))
   LastChar = LastChar - Len(FndString) + Len(InsertString)
   Next_Pos = 0
   Next_Pos = InStr(Next_Pos + 1, tempstring, FndString)
loop
Find_Replace = tempstring
end function

sub Substitute (inrecord, workrecord, Bypass, parsearray, parseRS)
   dim tokenformat
   dim tokens(5)
   dim tokencount
   dim rc
   dim morefields
   dim dbindex
   dim dbfieldname
   dim dbvalue
   dim dbvalue1
   dim token
   dim Newrecord
   dim fieldfound
   dim pos
   dim endpos
   dim specchar
   dim dbvalue2
   dim firstchar
   dim length
   pos = 1
   Bypass=False
   workrecord = inrecord
   morefields = True

   'VP-ASP 6.50.4 Bugs Fix - 08 October 2008
   fieldfound = ""        'used to determine if record is ouput if starts with a $
   firstchar = Left(workrecord, 1) ' save first character
   do while morefields = True
      pos = InStr(pos, workrecord, "[")
      if pos > 0 then
         endpos = InStr(pos, workrecord, "]")
         if endpos=0 then
            WriteError "Missing ] on field starting at " & Pos
            morefields=false
         else
       	    length = endpos - pos + 1
	        tokenformat=""
    	    token = Mid(workrecord, pos, length)
	        specchar = Mid(token, 2, 1)
    	    dbfieldname = Mid(token, 2, length - 2)
	        ParseRecord dbfieldname, tokens, tokencount, " "
    	    if tokencount> 1 then
      	       dbfieldname=tokens(1)
		       tokenformat=ucase(tokens(0))      ' formatcurrency, formatnumber
            end if

 	        '6.50 - translate GetLang in Templates
	        if lcase(tokenformat)="getlang" then
	           handle_GetLang dbfieldname, dbvalue
    	       Newrecord = Find_Replace(workrecord, token, dbvalue, 0)
	           workrecord = Newrecord
    	    else
			   '700 - home page manager - random products
			   if lcase(tokenformat)="loadcontainer" then
				  Handle_loadcontainer dbvalue, dbfieldname
				  Newrecord = Find_Replace(workrecord, token, dbvalue, 0)
				  workrecord = Newrecord
			   else
                  '6.50.4 Bugs Fix - 08 October 2008
        	      Parsearray(ptokenformat)=tokenformat
			   
	              Parsearray(ptokens)=tokens
  		          FindField dbfieldname, dbvalue, rc, parsearray, parseRS
		          if rc > 0 then exit sub
		          Newrecord = Find_Replace(workrecord, token, dbvalue, 0)
                  if dbvalue <> "" then
                     if fieldfound <> False then
                        fieldfound = True ' used to determine if record written
                     end if
                  else
                     fieldfound = False 
                  end if
                  workrecord = Newrecord


			   end if
	        end if
		 end if
      else
         morefields = False
      end if
   loop

   'at this point if record starts with a $ and no fields Substituted, do not write it
   if firstchar = "$" then
      if fieldfound = False then
         workrecord=""
         Bypass=True
         exit sub
      else
         length = Len(workrecord) - 1
         Newrecord = Mid(workrecord, 2, length)
         workrecord = Newrecord
         bypass=False
      end if
   end if
   Bypass=False
end sub

sub WriteError (msg)
   ShopWriteError  msg
end sub

sub FindField(fieldname, value, rc, parsearray, parsers)
   dim i
   dim temparea
   dim ucfieldname
   dim Fieldtype
   ucfieldname = UCase(fieldname)
   rc = 0
   ProcessKeyword ucfieldname, value, rc, parsearray, parseRS
   if rc = 0 then exit sub
   rc = 0
   FindInDatabase ucfieldname, temparea, fieldtype ,rc, parsearray
   if rc > 0 then
      WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
      value=""
      exit sub
   end if

   if temparea="" then
      value=""
      exit sub
   end if
   DoSpecialFormating temparea, Parsearray, parseRS
   value = temparea
end sub

sub FindInDatabase (fieldname, fieldvalue, fieldtype, rc, parsearray)
dim i
dim fieldcount, fieldvalues, fieldtypes, fieldnames
fieldname=ucase(fieldname)
fieldcount=parsearray(pfieldcount)
fieldnames=parsearray(pfieldnames)
fieldvalues=parsearray(pfieldvalues)
fieldtypes=parsearray(pfieldtypes)
for i=0 to fieldcount
   if fieldname=Fieldnames(i) then
      fieldvalue=fieldvalues(i)
      fieldtype=fieldtypes(i)


	   '6.50 - show placeholder if no image is available
	   if lcase(fieldname)="cimageurl" then
	      if fieldvalue="" then
	         fieldvalue=GetConfig("xnoimage")
	       end if
	   end if
	   if lcase(fieldname)="extendedimage" then
	      if fieldvalue="" then
	         fieldvalue=GetConfig("xnoimage")
	      end if
	   end if

      'fix for memcdescription
	   if lcase(fieldname)="cdescription" then
	      if memcdescription<>"" then
	         fieldvalue=memcdescription
	      end if
	   end if
      rc=0
      exit sub
   end if
next
rc=4
fieldvalue=""
end sub

sub ProcessKeyword (keyword, value, rc, parsearray,parseRS)
   dim tokenformat
   tokenformat=parsearray(ptokenformat)
   rc=4

   select case keyword
      case "ADD_OITEMS"
         Handle_OITEMS value, parsearray,parseRS
         rc=0
	   '6.50 - call random product display from Template
   	   case "ADD_RANDOMPRODUCTS"
         Handle_RANDOMPRODUCTS value, parsearray
         rc=0
      case "ADD_PAGEHEADER"
         Handle_PAGEHEADER value, parsearray
         rc=0
      case "ADD_PAGETRAILER"
         Handle_PageTrailer value, parsearray
         rc=0
      case "SPECIAL_ORDERBUTTON"
         Handle_SpecialOrderButton value,parsearray,parseRS
         rc=0
      case "SPECIAL_CHECKBOX"
         Handle_SpecialCheckbox value,parsearray
         rc=0
      case "ADD_FORMSTART"
	     '6.09 - added xMySite call
		 if trim(xMySite) <> "" then
            Handle_FormStart "User",parsearray, xMySite & "/shopaddtocart.asp"
         else
		    Handle_FormStart "User",parsearray, xMySite2 & "/shopaddtocart.asp"
		 end if
         rc=0
      case "ADD_FORMEND"
         Handle_FormEnd "User",parsearray
         rc=0
      case "ADD_PRODUCTFEATURES"
         Add_ProductFeatures "User",parsearray,"", parseRS
         rc=0
      case "ADD_QUANTITY"
	     '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		 else
            Add_Quantity "User",parsearray
            rc=0
	   	 end if
      case "ADD_ORDERBUTTON"
	   	 '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		 else
            Add_Button "User",parsearray
            rc=0
		 end if
      case "ADD_CHECKBOX"
         '6.5.1 - don't display this if xpriceloggedinonly = True and customer isn't logged in
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		 else
            Add_Checkbox "User",parsearray
            rc=0
		 end if
      case "ADD_TABLE"
         Add_Table "User",parsearray
         rc=0
      case "ADD_TABLEEND"
         Add_TableEnd "User",parsearray
         rc=0
      case "ADD_PRODUCT"
         Add_Product "User",parsearray
         rc=0
      case "INCLUDE"
         Handle_Include value,parsearray
         rc=0
      case "ADD_CROSSSELLING"
         Handle_CROSSSELLING value,parsearray, parseRS
         rc=0
      case "SUB"
	     select case ucase(tokenformat)
		    '700 - New Products Widget
		    case "DISPLAYNEWPRODUCTS"
			   displaynewproducts
			   rc=0
            case else
			   Handle_Product ucase(tokenformat)
			   rc=0
		 end select
      case "ADD_OITEMSTEMPLATE"
         Handle_OITEMSTemplate value, parsearray, parseRS
         rc=0
      case "ADD_OITEMTOTAL"
         Handle_OitemTotal value, parsearray, parseRS
         rc=0
      case "ADD_OITEMDELIVERY"
         Handle_OitemDelivery value, parsearray, parseRS
         rc=0
      case "ADD_RATINGSUMMARY"
         Handle_RatingSummary value, parsearray, parseRS
         rc=0
      '6.50 - add handler to show/hide review links
      case "ADD_REVIEWLINKS"
         Handle_ReviewLinks value, parsearray, parseRS
  	     rc=0
  	  '6.50 - add handler to show/hide add to comparison link
      case "ADD_COMPARELINKS"
         Handle_CompareLinks value, parsearray, parseRS
	      rc=0
      case "ADD_INVENTORYPRODUCTS"
         Handle_INVENTORYPRODUCTS value,parsearray, parseRS
         rc=0
      case "INVOICE_OITEMS"
         Handle_INVOICEOITEMS value,parsearray, parseRS
         rc=0
      case "DISPLAY_QUANTITYDISCOUNTS"
         'redundant
      case "ADD_WEBSESSLINK"
         Handle_ADDWEBSESSLINK value,parsearray, parseRS
         rc=0
      case "ADD_ALSOBOUGHT"
         Handle_ALSOBOUGHT value,parsearray, parseRS
         rc=0
      case "FORMATBREADCRUMB"
         Handle_Breadcrumb value,parsearray, parseRS
         rc=0
      '6.50 - show the number of sub-categories next to category listing
      case "ADDNUMBERSUBCATS"
         Handle_NumberSubCats value,parsearray, parseRS
         rc=0
   end select 
end sub

sub DoSpecialFormating (value, parsearray, parseRS)
   '700 - Tax Inclusive/Exclusive Price Display - inclusive price
   dim taxamount, oprice, rctax, taxdone, tax, pst   
   
   dim tokenformat
   tokenformat=parsearray(ptokenformat)
   if tokenformat="" then exit sub
   dim strprice
   dim inventorycheck
   select case ucase(tokenformat)
   case "FORMATCURRENCY"
      if GetConfig("xdisplayprices") <> "No" then
		 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
            value = ShopFormatCurrency(value,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
	  end if
   case "DUALPRICE"
      if GetConfig("xdisplayprices") <> "No" then
	     if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
			value=""
		 else
            GetDualPricevalue value, strPrice, parsearray
            value = formatnumber(strprice,GetConfig("xdecimalpoint"))
		 end if
	  else
		 value = ""
	  end if
   case "FORMATNUMBER"
      value = formatnumber(value,GetConfig("xdecimalpoint"))
   case "FORMATDATE"
      value = shopdateformat(value,GetConfig("xdateformat"))
   case "FORMATCUSTOMERPRICE"
      'redundant
   case "FORMATTAXINCLUSIVE"
      '700 - Tax Inclusive/Exclusive Price Display - inclusive price
      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    value = ""
		 else
            Tax = 0
            taxdone = false
			oprice = value
			taxamount = 0
			rctax = 4
            TaxCheckcustomerexcept dbc, rctax
            if rctax = 0 then
               value = ""
			else
               if ucase(GetSess("country")) = "CA" then
                  TaxbyCanada value, tax, taxdone, dbc, pst
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
               end if
			   
			   if taxamount <= 0 then
			      TaxbyState value, tax, taxdone, dbc
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxforEU value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  Taxbycountry value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value
                     else
					    value = value + taxamount
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxbyProductID tax, taxdone, value, parseRS("catalogid")
                  if taxdone = true then
				     taxamount = tax
					 value = value + taxamount
                  else
				     taxamount = 0
                  end if
			   end if
            end if

			'$10.00 inc TAX ; $8.88
			if taxamount > 0 then
               value = ShopFormatCurrency(value,GetConfig("xdecimalpoint")) & " Inc. Tax " & ShopFormatCurrency(taxamount,GetConfig("xdecimalpoint"))
            else
			   value = ""
			end if
		 end if
	  else
		 value = ""
	  end if
   case "FORMATTAXEXCLUSIVE"
      '700 - Tax Inclusive/Exclusive Price Display - exclusive price
      if GetConfig("xdisplayprices") <> "No" then
	  	 if (GetConfig("xpriceloggedinonly") = "Yes") AND (GetSess("Login") = "") then
		    value = ""
		 else
            Tax = 0
            taxdone = false
			oprice = value
			taxamount = 0
			rctax = 4
            TaxCheckcustomerexcept dbc, rctax
            if rctax = 0 then
               value = ""
			else
               if ucase(GetSess("country")) = "CA" then
                  TaxbyCanada value, tax, taxdone, dbc, pst
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
               end if
			   
			   if taxamount <= 0 then
			      TaxbyState value, tax, taxdone, dbc
                  if taxdone = True then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxforEU value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
					    value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  Taxbycountry value, tax, taxdone, dbc
                  if taxdone = true then
				     taxamount = tax
				     if GetConfig("xtaxincludedinprice") = "Yes" then
					    value = value - taxamount
                     else
						value = value
					 end if
                  else
				     taxamount = 0
                  end if
			   end if
			   
			   if taxamount <= 0 then
                  TaxbyProductID tax, taxdone, value, parseRS("catalogid")
                  if taxdone = true then
				     taxamount = tax
					 value = value
                  else
				     taxamount = 0
                  end if
			   end if
            end if

			'$10.00 inc TAX ; $8.88
			if taxamount > 0 then
               value = ShopFormatCurrency(value,GetConfig("xdecimalpoint")) & " Exc. Tax " & ShopFormatCurrency(taxamount,GetConfig("xdecimalpoint"))
            else
			   value = ""
			end if
		 end if
	  else
		 value = ""
	  end if	  

   case "URLENCODE"
      value = server.urlencode(value)
   case "FORMATSAVING"
      'redundant
   case "FORMATTIME"
      value = formatdatetime(value,vbshorttime)
   case "DUALCUSTOMERPRICE"
	  'redundant
   case "DUALSAVING"
	  'redundant
   case "FORMATIMAGE"
      value = HandleFormatImage(value)
   case "FORMATOITEMTOTAL"
      value = Handleformatoitemtotal(value)
   case "FORMATCURRENCYCONVERSION"
      value=HandleFormatCurrencyConversion (value, parsearray,parseRS)
   case "TRANSLATE"
      Handle_Translate value,parsearray, parseRS
   '6.09 - Remove HTML from meta and title tags
   case "CLEANSEHTML"
      Handle_cleansehtml value,parsearray, parseRS
   '6.09 - Translate keywords in shopdisplayproducts.asp and shopexd.asp
   case "GetLang"  
      Handle_GetLang value,parsearray, parseRS

   '7.00.1 - cross selling / also bought
   case "FORMATCROSSCHECKBOX"
	  dim strhassubproduct,fieldtype,rc,strfeatures
	  FindInDatabase "HASSUBPRODUCT", strhassubproduct, fieldtype ,rc, parsearray
	  FindInDatabase "FEATURES", strfeatures, fieldtype ,rc, parsearray
	  if getconfig("xcrossselling")="Yes" then
	     if instr(lcase(request.ServerVariables("script_name")),"shopaddtocart.asp")>0 then
	        value=""
		 else
		    if strhassubproduct="Yes" or (strfeatures<>"" and isnull(strfeatures)=false) then
		       value="<a href='shopexd.asp?id=[catalogid]'>" & getlang("LangCommonView") & "</a>"
		    else
	           value="<input type='checkbox' name='catalogid' value='[catalogid]'>"
			end if
		 end if
	  else
	     value=""
      end if
   end select
end sub

'Template format order items
'expects dbc to be open as open connection
sub Handle_OITEMS (body, parsearray,parseRS)
dim Isql, deliveryaddress, deliveryarray
dim orderid
dim rsitems
dim recordid
dim CR, itemname
dim downloadlink
recordid=parsearray(pidvalue)
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
isql="select * from oitems where orderid="

'7.01 - 2010.10.11 - Bug Fix: Send wrong orders items information if processed orders directly after the process of "Restore Order"
if trim(recordid)<>"" then
   Orderid=recordid
else
   Orderid=GetSess("oid")
end if

Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
rsitems.open Isql, dbc, adOpenDynamic, adLockOptimistic
do while Not RSItems.EOF
   itemname=rsitems("itemname")
   if GetConfig("xdeliveryaddress")="Yes" then
      deliveryaddress=rsitems("address")
      if not isnull(Deliveryaddress)  and Deliveryaddress<>"" then
         ConvertDeliveryToArray DeliveryArray, Deliveryaddress
         GetDeliveryName Itemname, DeliveryArray
      end if
   end if
   if ucase(GetSess("emailformat"))<>"HTML" then
      Itemname=RemoveHtmlFileio(itemname, CR)
   end if
   Body = Body & CR & Itemname & CR
   Body = Body &  GetLang("LangProductQuantity") & ": " & RSItems("numitems")  & CR
   if GetConfig("xDisplayPrices")<>"No" then
      Body = Body &  GetLang("LangProductPrice") & ": " & ShopFormatCurrency(RSItems("unitprice"),GetConfig("xdecimalpoint")) & CR
   end if
   if GetConfig("xendoforderhyperlinkemail")="Yes" or GetConfig("xdownloadsemail")="Yes" then
      downloadlink=GetEmaildownloadLink(RSItems("CatalogId"))
      if downloadlink <> "" then
         Body = Body & GetLang("LangorderDownload") & ": " & downloadLink  & CR
      end if
   end if
   RSItems.MoveNext
loop
rsitems.close
Set rsitems=nothing
end sub

sub ShopReadEntireFile(Filename, Outarray, Outcount, parsearray)
dim i
dim NewRecord
dim fs,ts
dim rc
outcount=0
OpenInputFile Filename, fs, ts, rc
if rc> 0 then
   exit sub
end if
ReadEntireFile fs, ts, Outcount, OutArray, parsearray
CloseFile fs,ts, rc, parsearray
rc=0
end sub

sub Handle_PageHeader (value, parsearray)
dim Templatedisplay
Templatedisplay=parsearray(pTemplatedisplay)
Value=""
if TemplateDisplay="No" then exit sub
ShopPageHeader
end sub

'6.50 - call random product display from Template
sub Handle_RandomProducts (value, parsearray)
   dim Templatedisplay
   Templatedisplay=parsearray(pTemplatedisplay)
   Value=""
   if TemplateDisplay="No" then exit sub
   Displayrandomproducts
end sub

sub Handle_PageTrailer (value, parsearray)
dim Templatedisplay
Templatedisplay=parsearray(pTemplatedisplay)
Value=""
If TemplateDisplay="No" then exit sub
ShopPageTrailer
end sub

'add button to allow people to order but do not put this out if using
'Inventory products
'When using inventory products do not put out order button
Sub Handle_SpecialOrderButton (ivalue,parsearray,parseRS)
   dim rc, inventorycheck, pricedisplay, quantitydisplay
   Checkinventoryproducts ivalue,parsearray,parseRS, inventorycheck, pricedisplay, quantitydisplay, inventoryoutofstock
   '6.09 - added xMySite call
   'Handle_FormStart ivalue,parsearray,"shopaddtocart.asp"
   if inventorycheck=true then
      Handle_Inventoryproducts ivalue, parsearray,parseRS
   end if
   Add_Table "", parsearray
   prodindex=""
   Add_ProductFeatures "",parsearray,"",parseRS
   
   if inventorycheck=false  then
      Add_Quantity "",parsearray
   else
      if quantitydisplay=true then
         Add_Quantity "",parsearray
      end if
   end if

   '6.50 - if showing table layout don't show order button
   if inventorycheck = true then
	   if pricedisplay = false then
	      'no button
   	   else
		  Add_Button "",parsearray
  	   end if
   else
      Add_Button "",parsearray
   end if

   Add_Product "",parsearray
   Add_TableEnd "",parsearray
   'Handle_FormEnd "",parsearray
end sub

sub Add_Product (ivalue, parsearray)
dim Id, fieldtype, rc
dim fieldname
fieldname="CatalogId"
id=0
FindInDatabase fieldname, id, fieldtype ,rc, parsearray
if rc > 0 then
   WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
end if
%>
<input type="hidden" name="productid" value="<%=ID%>" />
<%
end sub

sub Add_Table (ivalue, parsearray)
dim tableflag
WriteForm TemplateTable
TableFlag="True"
parsearray(ptableflag)=tableflag
end sub

sub Add_TableEnd (ivalue, parsearray)
dim tableflag
WriteForm "</table>"
Tableflag=""
parsearray(ptableflag)=tableflag
end sub

sub Handle_SpecialCheckBox (ivalue, parsearray)
'6.09 - added xMySite call
if trim(xMySite) <> "" then
   Handle_FormStart ivalue, xMySite & "/shopproductselect.asp"
else
   Handle_FormStart ivalue, xMySite2 & "/shopproductselect.asp"
end if
Add_Table "",parsearray
Add_ProductFeatures "",parsearray, "0"
Add_Quantity "", parsearray
Add_CheckBox "",parsearray
Add_Button "",parsearray
Add_TableEnd "",parsearray
Add_ProductIndex "",parsearray
Handle_FormEnd "",parsearray
end sub

sub Add_ProductIndex (ivalue, parsearray)
WriteForm "<input type=""hidden"" name=""prodindex"" value=""1"" />"
end sub

sub Add_CheckBox (ivalue, parsearray)
dim Id, fieldname,fieldtype, rc
fieldname="CatalogId"
FindInDatabase fieldname, Id, fieldtype ,rc,parsearray
if rc > 0 then
   WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
end if
if TableFlag<>"" then
   response.write TemplateCheckboxRow  & TemplateCheckboxColumn
end if
WriteForm "<input type=""checkbox"" name=""Processed0"" value=""" & ID & """ />"
if TableFlag<>"" then
   WriteForm TemplateCheckboxColumnEnd
   response.write "</tr>"
end if
end sub

sub Add_Button (ivalue, parsearray)
   '6.50 - if xpriceloggedinonly set to yes and customer isnt logged in, they shouldn't be able to purchase
   if GetConfig("xpriceloggedinonly") = "Yes" then
      if isnull(GetSess("Login")) or GetSess("Login") = "" then
         exit sub
      end if
   end if

   if GetConfig("xproductcatalogonly") = "Yes" then
	  exit sub
   end if
   dim mytext, mybutton, tableflag
   tableflag=parsearray(ptableflag)
   dim fieldvalue
   dim rc
   dim Id, fieldname,fieldtype
   WriteNoStockMessage rc, parsearray
   if rc> 0 then
      response.write OutofStockColumn &  GetLang("LangOutOfStock") & OutofStockColumnEnd
      exit sub
   end if
   fieldname="CatalogId"
   FindInDatabase fieldname, Id, fieldtype ,rc,parsearray
   if rc > 0 then
      WriteError  "Field " & fieldname & " " &  GetLang("LangDatabaseFail")
   else
      ID=0
   end if
   if mytext="" then
      mytext=GetLang("langproductorder")
   end if
   if mytext="" then
      mytext="Order"
   end if
   mybutton=""
   fieldname="BUTTONIMAGE"
   fieldvalue=""
   FindInDatabase fieldname, fieldvalue, fieldtype ,rc,parsearray
   if fieldvalue<>"" then
      mybutton= fieldvalue
   else
      if GetConfig("xButtonImage") <>"" then
         mybutton=GetConfig("xButtonImage")
      end if
   end if
   if tableflag<>"" then
      response.write  TemplateButtonColumn
   end if
   if myButton="" then
      WriteForm  "<input class=""submitbtn"" type=""submit"" value="""  & mytext & """ name=""Order"">"
   else
      WriteForm "<input class=""imgbtn"" src=""" & mybutton & """ type=""image"">"
   end if
   if tableflag<>"" then
      response.write "</td></tr>"
   end if
end sub

sub Add_Quantity (ivalue, parsearray)
'6.50 - if xpriceloggedinonly set to yes and customer isnt logged in, they shouldn't be able to purchase
if GetConfig("xpriceloggedinonly") = "Yes" then
   if isnull(GetSess("Login")) or GetSess("Login") = "" then
      exit sub
   end if
end if

if GetConfig("xproductcatalogonly") = "Yes" then
	exit sub
end if
dim strminimumquantity, rc, tableflag, fieldtype
WriteNoStockMessage rc, parsearray
if rc> 0 then exit sub
tableflag=parsearray(ptableflag)
FindInDatabase "MINIMUMQUANTITY", strminimumquantity ,fieldtype, rc,parsearray
if strminimumquantity="" then
   strminimumquantity=0
end if
if strMinimumquantity=0 then
   if tableflag<>"" then
      response.write TemplateQuantityRow & TemplateQuantityColumn
   end if
%>
<input class="txtfield" type="text" size="2" maxlength="3" name="quantity" value="1" />
<%
   if tableflag<>"" then
      response.write TemplateQuantityColumnEnd
   end if
else
   GenerateMinimumList strMinimumquantity, parsearray
end if
end sub

sub GetFieldValues (RS, fieldnames, fieldvalues, fieldtypes, fieldcount)
dim i
dim fldname
i=0
for each fldName in RS.Fields
   fieldnames(i) = ucase(fldname.name)
   fieldTypes(i) = fldname.type
   if Fieldtypes(i)="201" then
      fieldvalues(i)=RS(i)
   end if
   i=i+1
next
fieldcount=i-1
for i=0 to fieldcount
   if fieldtypes(i)<>"201" then
      fieldvalues(i)=RS(i).value
   end if
   if isnull(fieldvalues(i)) then
      fieldvalues(i)=""
   end if
next
end sub

sub ParseRecord (record,words,wordcount,delimiter)
dim pos
dim recordl
dim bytex
dim temprec
dim maxwords
dim i
maxwords = 10
temprec = record
dim maxentries
pos = 1
wordcount = 0
'make sure word array is null
maxentries = UBound(words)
for i = 0 To maxentries - 1
   words(i) = ""
next
recordl = Len(temprec)
'first eliminate leading blanks
do
   bytex = Mid(temprec, pos, 1)
   while bytex = " " And pos <= recordl
      pos = pos + 1
      bytex = Mid(temprec, pos, 1)
   wend
   'copy word into word array
   while bytex <> delimiter And pos <= recordl
      words(wordcount) = words(wordcount) & bytex
      pos = pos + 1
      bytex = Mid(temprec, pos, 1)
   wend
   wordcount = wordcount + 1
   pos = pos + 1
   if wordcount > maxentries then exit sub
loop until pos > recordl
end sub

sub Add_ProductFeatures (ivalue, parsearray, Index,parseRS)
dim rc, fieldtype, tableflag
prodindex=index
tableflag=parsearray(ptableflag)
FindInDatabase "FEATURES", strfeatures, fieldtype, rc,parsearray

if rc=0 then
   FindInDatabase "SELECTLIST", strselectlist, fieldtype, rc,parsearray
   FindInDatabase "CatalogId", lngCatalogId, fieldtype, rc, parsearray
   if tableflag<>"" then
      WriteForm TemplateFeaturesRow  & TemplateFeaturesColumn
   end if
   FormatProductOptions
   if tableflag<>"" then
      Writeform TemplateFeaturesColumnEnd & "</tr>"
   end if
end if
end sub

sub Handle_FormStart (value, parsearray, action)
   dim Newaction
   '6.09 - added xMySite call
   if trim(xMySite) <> "" then
      newaction=xMySite & "/shopaddtocart.asp"
   else
      newaction=xMySite2 & "/shopaddtocart.asp"
   end if
   if action<>"" then
      newaction=action
   end if
%>
<form id="<%=value%>" name="<%=value%>" method="post" action="<%=newaction%>">
<%
end sub

sub Handle_FormEnd (ivalue, parsearray)
   addwebsessform
   WriteForm "</form>"
end sub

sub WriteForm (text)
   response.write text
end sub


'[filename INCLUDE]
'field=abc INCLUDE]
'abc is field in recordset
sub Handle_Include (ivalue,parsearray)
dim NewRecord, ucfieldname, tokens
dim recordObj, FsObj
dim rc
dim MyText
dim readcount
dim Bypass, filename, pos, fieldtype, filetype
dim values(10),valuecount
readcount=0
tokens=parsearray(ptokens)
filename=tokens(0)
pos=instr(filename,"=")
if pos>0 then
   ParseRecord filename,values,valuecount,"="
   ucfieldname=ucase(values(1))
   if ucase(values(0))="FIELD" then
      FindInDatabase ucfieldname, filename, fieldtype ,rc,parsearray
      if isnull(filename) or filename="" then
         exit sub
      end if
   else
      filename=values(1)
   end if
end if
dim savevalue
savevalue=parsearray(Pdatainmemory)
parsearray(Pdatainmemory)="No"
OpenInputFile Filename, fsObj, RecordObj, rc
if rc> 0 then
   parsearray(Pdatainmemory)=savevalue
   ShopWriteError  GetLang("LangReadFail")  & filename
   exit sub
else
   GetFileType filename,filetype
end if
ReadARecord RecordObj, MyText, rc, parsearray
do while rc=0
   if filetype="TXT" then
      ivalue=ivalue & Server.HTMLEncode(MyText)  & "<br />"
   else
      ivalue=ivalue &  mytext
   end if
   readcount=readcount+1
   ReadARecord RecordObj, MyText, rc, parsearray
loop
CloseFile fsObj,RecordObj, rc, parsearray
parsearray(Pdatainmemory)=savevalue
end sub

sub GetFileType(filename, filetype)
dim xtype
filetype="TXT"
xtype=ucase(right(filename,3))
select case xtype
   case "TXT"
      filetype="TXT"
   case "HTM"
      filetype="HTM"
   case "TML"
      filetype="HTM"
end select
end sub

sub GenerateMinimumList (strminimumquantity,parsearray)
end sub

function RemoveHtmlFileio(itemname, CR)
dim workrecord, firstchar, morefields, pos, endpos, length
dim token
workrecord=replace(itemname,"<br />",CR)

'VP-ASP 6.50.4 Bugs Fix - 08 October 2008
workrecord=replace(workrecord,"<br>",CR)
workrecord=replace(workrecord,"<br/>",CR)
workrecord=replace(workrecord,"<BR />",CR)
workrecord=replace(workrecord,"<BR>",CR)
workrecord=replace(workrecord,"<BR/>",CR)

pos=1
morefields = True
do while morefields = True
   pos=1
   pos = InStr(pos, workrecord, "<")
   if pos > 0 then
      endpos = InStr(pos, workrecord, ">")
      if endpos=0 then
         morefields=false
      else
         length = endpos - pos + 1
         token = Mid(workrecord, pos, length)
         workrecord=replace(workrecord,token,"")
      end if
   else
      morefields=false
   end if
loop
RemoveHtmlFileio=workrecord
end function

'add logic to test sub products out of stock
sub WriteNoStockMessage (rc, parsearray)
dim lngcstock,id,fieldtype,rc1, fieldname
rc=0
if Inventoryoutofstock=true then
   rc=4
   exit sub
end if
if GetConfig("xOutOfStockLimit")="" then exit sub
fieldname="CSTOCK"
FindInDatabase fieldname, lngcstock, fieldtype ,rc1, parsearray
if isnull(lngcstock) then exit sub
If lngcstock="" then exit sub
if clng(lngcstock)>clng(GetConfig("xOutOfStocklImit")) then exit sub
rc=4
end sub

sub ShopMergeTemplate (DBTable, Template, CatalogId, IDField)
    dim tempDatabase, tmprs, rc
    if isnumeric (CatalogId) then
       Sql="select * from " & DBTable
       if IDField<>"" then
          sql=sql & "  where " & IDField & "="  & CatalogId
       end if
    else
       sql="select * from " & DBTable
       if IDField<>"" then
          sql=sql & "  where " & IDField & "='"  & CatalogId & "'"
       end if
    end if
    Set tmpRS = Server.CreateObject("ADODB.Recordset")
    tmpRS.open sql, dbc, adOpenDynamic, adLockOptimistic
    if tmpRS.eof then
       if CatalogId<>"" then
          SError = SError &  GetLang("LangReadFail") & "-" & GetLang("LangEditTableName") & "=" & DBTable
       else
          SError = SError &  GetLang("LangReadFail") & " " & GetLang("langedittablename") & "=" & DBTable
       end if
    end if
    if SError="" then
       ShopTemplateWrite  Template, tmpRS, rc
    end if
    CloseRecordSet tmpRS
end sub

function HandleCustomerPrice (iprice, parsearray,parseRS)
'redundant
end function

function HandlePriceSAving (iprice, parsearray,parseRS)
'redundant
end function

'Template format order items
'expects dbc to be open as open connection
sub Handle_OITEMSTemplate (body, parsearray,parseRS)
dim filename, outarray(10), outcount, suffix, emailformat
filename=GetConfig("xoitemsTemplate")
dim Isql,orderid, rsitems
dim recordid
dim CR, itemname, i
dim downloadlink
recordid=parsearray(pidvalue)
Suffix=right(filename,3)
if ucase(suffix)<>"TXT" then     ' oct 6
   SetSess "emailformat","HTML"
else
   SetSess "emailformat","TEXT"
end if
if ucase(GetSess("emailformat"))="HTML" then
   CR=""
else
   CR = GetMailCR
end if

isql="select * from oitems where orderid="
if GetSess("oid")<>"" then
   Orderid=GetSess("oid")
else
   Orderid=recordid
end if
Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
rsitems.open Isql, dbc, adOpenDynamic, adLockOptimistic
if rsitems.eof then
   CloseRecordSet rsitems
   exit sub
end if
do while not rsitems.eof
   ShopTemplateArray Filename, RSITEMS, Outarray, Outcount
   for i = 0 to outcount-1
      itemname=outarray(i)
      if ucase(GetSess("emailformat"))<>"HTML" then
         Itemname=RemoveHtmlFileio(itemname, CR)
      end if
      Body = Body & CR & Itemname
   next
   if GetConfig("xendoforderhyperlinkemail")="Yes" or GetConfig("xdownloadsemail")="Yes" then
      downloadlink=GetEmaildownloadLink(RSItems("CatalogId"))
      if downloadlink <> "" then
         Body = Body & GetLang("LangorderDownload") & ": " & downloadLink  & CR
      end if
   end if
   rsitems.movenext
loop
CloseRecordSet rsitems
end sub

sub Handle_OitemTotal(value,parsearray,parseRS)
dim quantity, unitprice, rc, fieldtype, price, total
FindInDatabase "NUMITEMS", quantity, fieldtype ,rc, parsearray
FindInDatabase "UNITPRICE", unitprice, fieldtype ,rc, parsearray
Total=quantity*unitprice
value=ShopFormatCurrency(total,GetConfig("xdecimalpoint"))
end sub

sub Handle_OitemDelivery(value,parsearray,parseRS)
dim rc, fieldtype, price, total, itemname
dim CR
dim deliveryaddress, deliveryarray
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
if GetConfig("xdeliveryaddress")="Yes" then
   FindInDatabase "ADDRESS", deliveryaddress, fieldtype ,rc, parsearray
   if not isnull(Deliveryaddress)  and Deliveryaddress<>"" then
      ConvertDeliveryToArray DeliveryArray, Deliveryaddress
      GetDeliveryName Itemname, DeliveryArray
      if ucase(GetSess("emailformat"))<>"HTML" then
         Itemname=RemoveHtmlFileio(itemname, CR)
      end if
      value=itemname
   end if
end if
end sub

'see if Template is in Database. If it is open the recordset
'put whole Template into fsobj
sub OpenInputFiledb (filename, fsObj, RecordObj, rc)
dim dbprefix, dbfilename
dbprefix=left(filename,3)
if lcase(dbprefix)="db=" then
   dbfilename=right(filename,len(filename)-3)
else
   dbfilename=filename
end if
dim sql
'700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
sql="select * from Templates where Templatename="& sqlserverprefixn &"'" & dbfilename & "'"
if GetConfig("xdebug")="Yes" then
   DebugWrite sql
end if
Set recordobj = Server.CreateObject("ADODB.Recordset")
recordobj.open sql, dbc, adOpenDynamic, adLockOptimistic
if not recordobj.eof then
   rc=0
   fsobj=recordobj("Template")
else
   rc=4
end if
CloseRecordSet recordobj
recordobj=""
If rc=0 then
   recordobj="db"
end if
end sub

sub ReadEntireFileDB  (fsoobj, RecordObj, readcount, readarray,parsearray)
dim data, delimiter, i
delimiter="~"
readcount=0
data=replace(fsoobj,vbcrlf,delimiter)
ParseRecord data, readarray, readcount,delimiter
end sub

'Record are already in memory in the parse arary
sub ReadARecordDB (RecordObj, record, rc,parsearray)
dim data, currentrecord, recordcount
currentrecord=parsearray(pdatacurrentrecord)
recordcount=parsearray(pdatarecordcount)
data=parsearray(pdata)
if currentrecord=recordcount then
   rc=4
   exit sub
end if
record=data(currentrecord)
currentrecord=currentrecord+1
parsearray(pdatacurrentrecord)=currentrecord
rc=0
end sub

sub CheckfileDB(filename,fieldname,rc)
dim dbprefix
dbprefix=left(filename,3)
if lcase(dbprefix)="db=" then
   fieldname=right(filename,len(filename)-3)
   rc=0
else
   fieldname=""
   rc=4
end if
end sub

sub Handle_RatingSummary (value, parsearray, parseRS)
dim oaverage,image, count
dim fieldtype, rc, lngCatalogId, fieldname
if GetConfig("xAllowRatingProducts")<>"Yes" then exit sub
if GetConfig("xAllowRatingSummary")<>"Yes" then exit sub
fieldname="CatalogId"
FindInDatabase fieldname, lngCatalogId, fieldtype ,rc, parsearray
FileioReviewaverage lngCatalogId, oaverage,image, count, dbc
if image="" then
   response.write "<p class=""al"">" & GetLang("langNoReviews") & "</p>"
   exit sub
end if
response.write "<p class=""al"">"
response.write count & "&nbsp;" & GetLang("langratingheader")  & "<br />"
response.write "<img src=""" & image & """ alt="" "" /></p>"
end sub

sub FileioReviewAverage(CatalogId, oaverage, image, outcount, dbc)
dim rs, rsql, strrating
rsql=" SELECT CatalogId, Avg(rating) AS avgofrating, count(CatalogId) as countCatalogId from reviews where CatalogId=" & CatalogId & " AND authorized IS NOT NULL GROUP BY CatalogId"
Set rs = Server.CreateObject("ADODB.Recordset")
rs.open rsql, dbc, adOpenDynamic, adLockOptimistic
if not rs.eof then
   oaverage=rs("avgofrating")
   oaverage=clng(oaverage)
   strrating=cstr(oaverage)
   outcount=rs("countCatalogId")
   select case strrating
      case "1"
         image="vpasp_stars1.gif"
      case "2"
         image="vpasp_stars2.gif"
      case "3"
         image="vpasp_stars3.gif"
      case "4"
         image="vpasp_stars4.gif"
      case "5"
         image="vpasp_stars5.gif"
      case else
         image=""
   end select
   '600 - moved images to images/misc folder
   if image > "" then
   	image = "images/misc/" & image
	end if
else
   oaverage=""
   image=""
end if
rs.close
set rs=nothing
end sub

function HandleFormatImage (fieldvalue)
dim newvalue
if fieldvalue="" then
   handleFormatImage=""
   exit function
end if
newvalue="<img border=""0"" src=""" & fieldvalue & """ alt="" ""/>"
handleFormatImage=newvalue
end function

'add Inventory Products. Codse is in shopproductinventory
sub Handle_Inventoryproducts (ivalue, parsearray,parseRS)
if GetConfig("xinventoryproducts")<>"Yes" then exit sub
FormatInventoryproducts dbc, parseRS
end sub

'if there are associated products then display them
'instead of the order button
sub Checkinventoryproducts (ivalue,parsearray,parseRS, inventorycheck,inventorypricedisplay, quantitydisplay, inventoryoutofstock)
dim CatalogId, spdisplaytype
inventorycheck=false
quantitydisplay=true
if GetConfig("xinventoryproducts")<>"Yes"  then exit sub
dim strCrossProductIDs,strsql, rs
dim fieldtype,rc
FindInDatabase "INVENTORYPRODUCTS", strcrossProductids, fieldtype, rc, parsearray
FindInDatabase "CatalogId", CatalogId, fieldtype, rc, parsearray
FindInDatabase "SPDISPLAYTYPE", spdisplaytype, fieldtype, rc, parsearray
InventoryProductYesNo dbc, ParseRs, CatalogId, inventorycheck, Inventorypricedisplay, quantitydisplay, inventoryoutofstock
end sub

'Template format order items
'expects dbc to be open as open connection
'$H is one type header
'$T is one time trailer
sub Handle_INVOICEOITEMS (value,parsearray, parseRS)
dim filename, outarray(500), outcount, suffix, emailformat
dim headerwritten
dim body, record, outrec, prefix
filename=GetConfig("xinvoiceoitemsTemplate")
filename="tmp_invoiceoitems.htm"
headerwritten=false
dim Isql,orderid, rsitems
dim recordid
dim CR, itemname, i
recordid=parsearray(pidvalue)
isql="select * from oitems where orderid="
Orderid=recordid
Body=""
ISql=Isql & Orderid
Set rsitems = Server.CreateObject("ADODB.Recordset")
rsitems.open Isql, dbc, adOpenDynamic, adLockOptimistic
if rsitems.eof then
   CloseRecordSet rsitems
   exit sub
end if
do while not rsitems.eof
   ShopTemplateArray Filename, RSITEMS, Outarray, Outcount
   for i = 0 to outcount-1
      record=outarray(i)
      outrec=Striprecord(record)
      prefix=ucase(left(record,2))
      if prefix=";T" then
         outrec=""
      end if
      if headerwritten=true then
         if prefix=";H" then
            outrec=""
         end if
      end if
      if outrec<>"" then
         response.write outrec & vbcrlf
      end if
   next
   headerwritten=true
   rsitems.movenext
loop
CloseRecordSet rsitems
for i = 0 to outcount-1
   record=outarray(i)
   outrec=striprecord(record)
   prefix=ucase(left(record,2))
   if prefix=";T" then
      response.write outrec & vbcrlf
   end if
next
end sub

'Display quantity discounts
sub Handle_Quantitydiscounts(value,parsearray,parseRS)
   'redundant
end sub

function StripRecord(inrec)
dim prefix, newrec
prefix=ucase(left(inrec,2))
newrec=inrec
if prefix=";H" or prefix=";T" then
   newrec=mid(inrec,3,len(inrec)-2)
end if
striprecord=newrec
end function

'adds &websess=xxxxxxxxxxxxxxxx
Sub Handle_ADDWEBSESSLINK( value,parsearray, parseRS)
value=addwebsesslink
end sub

'Create hyperlink to currency converter
function HandleFormatCurrencyConversion (total, parsearray,parseRS)
dim value, cprice
value=""
if GetConfig("xproductConvertCurrency")="Yes"  then
   cprice=ShopFormatNumber(total,GetConfig("xdecimalpoint"))
   ShopConvertCurrencyLink  cprice, value
end if
HandleFormatCurrencyConversion=value
end function

sub GetDualPricevalue( value, strcprice, parsearray)
dim dualpricefield
if GetConfig("xdualpricefield")=""  then
   ConvertCurrency value, strcPrice
   exit sub
end if
dualpricefield=GetConfig("xdualpricefield")
dim fieldtype,rc
FindInDatabase ucase(dualpricefield), strcprice, fieldtype, rc, parsearray
if isnumeric(strcprice) then exit sub
strcprice=value
end sub

'[Translate cdescription  products]
'[translate catdescription categories]
sub Handle_translate (value,parsearray, ParseRs)
dim tokens, fieldname, table, IDField, idvalue, currentvalue
dim fieldvalue, fieldtype, rc, ucfieldname
tokens=parsearray(ptokens)
fieldvalue=value
fieldname=tokens(1)
table=tokens(2)
if table = "" then
	table = GetSess("table")
end if
if table="" then
   table="products"
else
   table=lcase(table)
end if
if fieldname="" then
   value=" Unknown field to translate "
   exit sub
end if
IDField=parsearray(pIDField)
idvalue=parsearray(pidvalue)
ucfieldname=ucase(fieldname)
value=TranslateLanguage(dbc, table, fieldname,IDField, idvalue, fieldvalue)
end sub

'Remove HTML from title and meta tags
sub Handle_cleansehtml (value,parsearray, ParseRs)
dim cr
if ucase(GetSess("emailformat"))="HTML" then
   CR="<br />"
else
   CR = GetMailCR
end if
value=RemoveHtmlFileio(value, CR)
end sub

'VP-ASP 6.5
'[GetLang xxx]
'takes xxx and looks it up in language table
sub Handle_GetLang (langvalue, value)
   value=GetLang(langvalue)
end sub

'Get download links in email
'This was 6.08 version. in 6.50 go backl to emailist array
function GetEmaildownloadLinkold (CatalogId)
'6.08 fix for email link
dim i, downloadsql, downloadrs
downloadsql = "select " & GetConfig("xendoforderhyperlinkfield") & " from products where CatalogId = " & CatalogId
Set downloadrs = Server.CreateObject("ADODB.Recordset")
downloadrs.open downloadsql, dbc, adOpenDynamic, adLockOptimistic
if not downloadrs.eof then
	GetEmaildownloadLink=downloadrs(GetConfig("xendoforderhyperlinkfield"))
else
	GetEmaildownloadLink=""
end if
CloseRecordSet downloadrs
end function

'display also bought values
sub Handle_ALSOBOUGHT (value,parsearray, parseRS)
   if GetConfig("xalsobought")<>"Yes" then exit sub
   dim fieldtype,rc, productname
   FindInDatabase "CatalogId", CatalogId, fieldtype, rc, parsearray
   FindInDatabase "CNAME", productname, fieldtype, rc, parsearray
   If rc>0 then exit sub
   FormatAlsoBought CatalogId, productname
end sub

'6.00 - Bread crumb code for extended desc
sub Handle_Breadcrumb (value, parsearray,parseRS)
if Request("bc")<>"" then exit sub
'6.50 - added config option to turn breadcrumb on/off
if GetConfig("xbreadcrumbs") <> "Yes" then exit sub
response.write session("breadcrumb")
%>
<hr />
<%
end sub

'6.50 - Show/Hide review links
sub  Handle_ReviewLinks (value, parsearray, parseRS)
dim fieldname, lngCatalogId,fieldtype,rc
if GetConfig("xallowratingproducts")<>"Yes" then exit sub
fieldname="CatalogId"
FindInDatabase fieldname, lngCatalogId, fieldtype ,rc, parsearray
if GetConfig("xbuttonwritereview")>"" then
	response.write "<a href=""shopreviewadd.asp?id=" & lngCatalogId & addwebsesslink & """><img src=""" & GetConfig("xbuttonwritereview") & """ alt=""" & GetLang("langratingwrite") & """ /></a>&nbsp;"
else
	response.write "<a href=""shopreviewadd.asp?id=" & lngCatalogId & addwebsesslink & """>" & GetLang("langratingwrite") & "</a>&nbsp;|&nbsp;"
end if

if GetConfig("xbuttonreadreview")>"" then
	response.write "<a href=""shopreviewlist.asp?id=" & lngCatalogId & addwebsesslink & """><img src=""" & GetConfig("xbuttonreadreview") & """ alt=""" & GetLang("langratingread") & """ /></a>"
else
	response.write "<a href=""shopreviewlist.asp?id=" & lngCatalogId & addwebsesslink & """>" & GetLang("langratingread") & "</a>"
end if

end sub

'6.50 - Show/Hide compare link
sub  Handle_CompareLinks (value, parsearray, parseRS)
end sub

'6.50 - show the number of sub-categories next to category listing
sub Handle_NumberSubCats (value, parsearray,parseRS)
   dim scrs
   Set scrs = Server.CreateObject("ADODB.Recordset")
   scrs.open "select hassubcategory from categories where categoryid = " & value, dbc, adOpenDynamic, adLockOptimistic
   if scrs.eof then
	  response.write "(-)"
   else
      if scrs("hassubcategory") = "Yes" then
   	  else
	     '6.50.1 - Add checks for hidden products, product matching, customer matching stock control to count
		 dim scsql
		 scsql = "select DISTINCT count(intCatalogId) AS thecount from prodcategories where intcategoryid = " & value

		 '6.50.4 - added UCASE to line below
		 if instr(ucase(xdatabasetype), "MYSQL") > 0 or instr(ucase(xdatabasetype), "SQLSERVER") > 0 then
		    scsql = scsql & " AND intCatalogId IN (SELECT CatalogId FROM products WHERE not hide = 1 "
		 else
		    scsql = scsql & " AND intCatalogId IN (SELECT CatalogId FROM products WHERE not hide = TRUE "
		 end if

		 if GetConfig("xstocklow")<>"" then
	        lngcstock= clng(GetConfig("xstocklow"))
		    scsql = scsql & " and cstock> " & lngcstock
		 end if

		 if GetConfig("xproductmatch")="Yes" then
		    scsql=scsql & " and "
		    GenerateProductmatchsqlsubs scsql    ' in shopproductsubs
		 end if

	     '700 - Customer Groups - Matching Custormer match
	     scsql = scsql & GenerateCustomerMatchSQL ("customermatch","and")

		 scsql = scsql & ")"
         Set scrs = Server.CreateObject("ADODB.Recordset")
         scrs.open scsql, dbc, adOpenDynamic, adLockOptimistic
		 if not scrs.eof then
		    response.write "(" & scrs("thecount") & ")"
		 else
		    response.write "(0)"
	     end if
	  end if
   end if
   CloseRecordSet scrs
end sub

'VP-ASP 6.50
'Get download links in email
function GetEmaildownloadLink(CatalogId)
end function
%>