<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' This routine gets the features from the form
' and stores them in the feature array
'*********************************************************************************

dim quantityproducts ' new facility for cloning

' called by shopaddtocart and shopproductselect
' Gets product options from form fields and stores them in
' Productoptions array
sub GetProductFeatures (prodi)
   dim sOption, sMultiOption, sMultivalue, soptionvalue, i
   dim susertext, susertextvalue
   dim featurename, featurevaluename
   dim dmaxfeatures, msg
   
   featurecount = 0
   userselectedstring = ""
   UserSelectedCount = 0
   if strfeatures = "" then exit sub
   if isnull(strfeatures) then exit sub

   '6504 - BUG FIXED - WISHLIST FOR SUBPRODUCTS
   if ucase(request("wlist")) = "Y" then
      ResponseRedirect("shopquery.asp?CatalogId="& prodid &"")
   end if

   dmaxfeatures = GetConfig("xmaxfeatures")
   fprefix = ""
   if prodi<>"" then
      fprefix = "x"
   end if
   sxRequiredList = fprefix & prodi & "Required"

   '6.50 - precautionary security fix
   sXRequiredvalue = CleanChars(request(sXRequiredList))
   
   featurecount = 0

   ' For each possible feature see if there is anything to process
   for i = 1 to dMaxFeatures
      sOption = fprefix & prodi & "Feature" & i
      sOptionNumber = i
      featureid = Request(Soption)

      '6.09 - precautionary security fix
      if featureid > "" then
         if lcase(featureid) <> lcase(GetLang("langCommonSelect")) then
            if not isnumeric(featureid) then
               ShopError "Feature ID must be numeric"
            end if
         end if
      end if

      featurevaluename = fprefix & prodi & "Featurevalue" & i

      '6.50 - precautionary security fix
      featurevalue = CleanChars(request(featurevaluename))
      if featureid<>"" then
         if isnumeric(featureid) then
            ProcessGetFeatureRecord dbc, featureid
            ProcessFeaturevalues
         end if
      end if
      if Susertextvalue<>"" then
         HandleCompatbilityUserText sUserText, sUserTextValue
      end if
   next
  
   '6.50 - precautionary security fix
   memUserText = CleanChars(request("UserText" & prodi))
   StrAllowUserText = CleanChars(request("UserCaption" & Prodi))

   SetSess "MaxFeatures", featurecount ' maximum features in array
   if featureerror<>"" then
      ShopError featureError
   end if
   VerifyRequired msg
   if msg<>"" then
      ShopError msg
   end if

   if GetConfig("xFeaturesRequired") = "Yes" then
      VerifyFeaturesSelected
   end if
end sub

'Reread the prod features tabler for this feature
sub ProcessGetFeatureRecord (dbc, featureid)
   dim featuresql, rs
   Featuresql = "select * from prodfeatures where id =" & featureid
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open featuresql, dbc, adOpenDynamic, adLockOptimistic
   if not rs.eof then
      GetOptionvalues rs, dbc
	  
   end if
   rs.close
   set rs = nothing
end sub

' A feature was obtained from the form
sub ProcessFeaturevalues
   dim featuretype
   featuretype = ucase(StrFeatureType)
   if featuretype = "" then
      if strFeatureOther<>"" then
         featuretype = "SELECTLIST" ' compatibility
      else
         featuretype = "DROPDOWN"
      end if
   end if
   FeatureMultiSelection = ucase(strFeatureMulti)
   select case featureType
      case "DROPDOWN"
         ProcessDropDownList
      case "CHECKBOX"
         ProcessCheckbox
      case "RADIO"
         ProcessRadioButton
      case "SELECTLIST"
         ProcessSelectList
      case "USERTEXT", "TEXTAREA"
         ProcessUserText
      case "USERPRICE"
         ProcessUserPrice ' generates same as user text
      case "MULTIPLIER"
         ProcessMultiplier ' generates same as user text
      case "QUANTITY"
         ProcessFeatureQuantity
      case "QTYPRODUCT"
         ProcessFeatureQuantityProduct
      case else
         ProcessDropDownList
   end select
end sub

' Drop down list can have a value or it can
sub ProcessDropDownList
   dim i
   if FeatureMultiSelection<>"YES" then
      ProcessFeatureAddToArray
      Featurecount = featurecount + 1
      exit sub
   end if
   ParseRecord featurevalue, featurevalueids, featurevaluecount, ","
   for i = 0 to featurevaluecount -1
      if isnumeric(featurevalueids(i)) then
         ProcessGetFeatureRecord dbc, featurevalueids(i)
         ProcessFeatureAddToArray
         Featurecount = featurecount + 1
      end if
   next
end sub

' check box can have multiple values
sub ProcessCheckBox
   dim i
   '701 - 2010.10.28 - Bug Fix: product features checkbox and radio should make multivalue automatially set
'   if FeatureMultiSelection<>"YES" then
'      ProcessRadioButton
'      exit sub
'   end if
   if featurevalue = "" then exit sub
   ParseRecord featurevalue, featurevalueids, featurevaluecount, ","
   for i = 0 to featurevaluecount -1
      if isnumeric(featurevalueids(i)) then
         ProcessGetFeatureRecord dbc, featurevalueids(i)
         ProcessFeatureAddToArray
         Featurecount = featurecount + 1
      end if
   next
end sub

' Drop Radio Button
sub ProcessRadioButton
   ProcessFeatureAddToArray
   Featurecount = featurecount + 1
end sub

' Process SelectList
' could be in form xxx or xxx [55.55]
' Value came from select list
sub ProcessSelectList
   dim name, price
   ParseOption featurevalue, name, price
   if name<> GetLang("Langcommonselect") then
      ProcessFeatureAddToArray
      Featurearray(cfeaturevalue, featurecount) = name
      Featurearray(cfeatureprice, featurecount) = price
	  dim tempstring
	  tempstring = getsess("tempfeatureotherpricing")
	  setsess "tempfeatureotherpricing",tempstring & "-selectlistprice=["& price &"]"
      Featurecount = featurecount + 1
   end if
end sub

' Process SelectList
' could be in form xxx or xxx [55.55]
' Value came from select list
sub ProcessUserText
   if featurevalue = "" then exit sub
   ProcessFeatureAddToArray
   Featurearray(cfeaturevalue, featurecount) = featurevalue
   Featurecount = featurecount + 1
end sub

' Process User Price
' could be in form xxx or xxx [55.55]
' Value came from select list
sub ProcessUserPrice
   dim price
   price = featurevalue
   '6.08 - error was being thrown if nothing was entered, even if feature not required
   if price > "" then
      if not isnumeric(price) then
         featureerror = featureError & GetLang("LangUserPriceError") & " " & strfeaturecaption & ".<br />" & GetLang("LangProductname") & " " & strcname & "<br />"
         exit sub
      end if

      '6.50 - handle currency conversions
      if cdbl(GetSess("Conversionvalue")) <> 1 then
         featurevalue = featurevalue / GetSess("Conversionvalue")
      end if
      ProcessFeatureAddToArray
      Featurearray(cfeatureprice, featurecount) = featurevalue

	  '701 - 2011.08.26 - Bug Fix: Feature userprice are not carry forward to checkout process
	  setsess "tempfeatureuserprice",featurevalue
	  
      Featurecount = featurecount + 1
   end if
end sub

' a multiplier multiplies the current price by the number selected
sub ProcessMultiplier
   dim multvalue, tempname, newprice, checkname, priceeach
   checkname = fprefix & Prodi & "FeatureQuantity" & sOptionNumber & "_" & featureid
   multvalue = request(checkname)
   if not isnumeric(multvalue) then
      ShopError GetLang("LangUserPriceError") & " - " & strcname
   end if

   '6.50.1 - limit number of multiplier available
   if len(multvalue) > 3 then
      ShopError "Quantity too large " & strcname
   end if

   ProcessGetFeatureRecord dbc, featureid
   price = ShopFormatCurrency(curfeatureprice, GetConfig("xdecimalpoint"))
   multvalue = csng(multvalue)

   '6.50.1 - ensure multiplier is not negative
   if multvalue<0 then
      ShopError "Amount cannot be a negative value  - " & strcname
   end if

   newprice = multvalue * curfeatureprice
   ProcessFeatureAddToArray
   tempname = strfeaturecaption & " (" & multvalue & " @ " & price & ")"
   Featurearray(cfeaturevalue, featurecount) = tempname
   Featurearray(cfeatureprice, featurecount) = newprice
   Featurecount = featurecount + 1
end sub

' adds the feature to an internal array of features selected
sub ProcessFeatureAddToArray
   Featurearray(cfeaturecaption, featurecount) = strfeaturecaption
   Featurearray(cfeatureprice, featurecount) = curfeatureprice
   Featurearray(cfeatureid, featurecount) = lngfeatureid
   Featurearray(cfeaturevalue, featurecount) = strfeaturename
   Featurearray(cfeatureother, featurecount) = strfeatureother ' for sku
   Featurearray(cfeaturenum, featurecount) = lngfeaturenum
   Featurearray(cfeatureweight, featurecount) = strfeatureweight
   Featurearray(cfeaturepercent, featurecount) = strfeaturepercent
   AddToSelectedFeatures lngfeatureid
end sub

' Verify if all features for this product have an entry in the feature array
sub VerifyFeaturesSelected
   dim j
   on error goto 0
   dim farray, found, featurenum
   dim FeatureNotSelected
   dim MaxFeatures
   
   '701 - 2010.10.15 - Bug Fix: Error while selecting products with feature to cart while xFeaturesRequired is Yes
   if strFeatures = "" then ' this product has no features
      exit sub
   end if
   
   farray = Split(strFeatures, ",") 'get feature numbers
   maxfeatures = ubound(farray) + 1
   if featurecount>= featurecount then
      for i = 0 to maxfeatures -1
         featurenum = clng(farray(i))
         found = false
         for j = 0 to featurecount -1
            '       DebugWrite "comparing " & featurenum & " with " & featurearray(cfeaturenum,j)
            if featurenum = clng(featurearray(cfeaturenum, j)) then
               found = true
               exit for
            end if
         next
         if found = false then
            exit for
         end if
      next
   else
      found = false
   end if
   if found = false then
      ShopError GetLang("LangFeatureMissing") & strcname
   end if
end sub

'The feature values have a list of ids
'we generate a form field based on this is and see if there is anything in them
sub ProcessFeatureQuantity
   dim quanarray, quanlimit, checkname, quantity, featureid
   dim totalnewprice, newprice, tempname, totalnewquantity
   QuanArray = split(featurevalue, ",", -1, 1)
   Quanlimit = ubound(Quanarray)
   totalnewprice = 0
   totalnewquantity = 0
   dim tempstring
   for i = 0 to quanlimit
      featureid = quanarray(i)
      checkname = fprefix & Prodi & "FeatureQuantity" & sOptionNumber & "_" & featureid
      quantity = request(checkname)
      Validatefeaturequantity quantity, rc
      if rc = 0 then
         ProcessGetFeatureRecord dbc, featureid
         ProcessFeatureAddToArray
         newprice = curfeatureprice
         newprice = csng(quantity) * newprice
         tempname = strfeaturename & "(" & quantity & ")</span>"
         Featurearray(cfeaturevalue, featurecount) = tempname
         Featurearray(cfeatureprice, featurecount) = newprice
         totalnewprice = totalnewprice + (curcprice * quantity)
         totalnewprice = totalnewprice + newprice
 	     tempstring = getsess("tempfeatureotherpricing")
		 setsess "tempfeatureotherpricing",tempstring & "-selectquantity=["& quantity &"]"
         Featurecount = featurecount + 1
      end if
   next
   if totalnewquantity>0 then
      SetSess "newproductprice", totalnewprice
      SetSess "newproductquantity", totalnewquantity
   end if
end sub

sub Validatefeaturequantity (quantity, rc)
   dim tquantity
   rc = 4
   if not isnumeric(quantity) then
      quantity = 1
      rc = 0
      exit sub
   end if
   tquantity = clng(quantity)
   if tquantity = 0 then exit sub
   rc = 0
end sub

' create a string of featureids that is added to the internal shopping cart
' and eventually stored with the product in the oitems table
sub AddToSelectedFeatures (featureid)
   UserSelectedCount = UserSelectedCount + 1
   if UserSelectedstring<>"" then
      Userselectedstring = userselectedstring & ","
   end if
   userselectedstring = UserselectedString & cstr(featureid)
end sub

' The feature values have a list of ids
'we generate a form field based on this is and see if there is anything in them
sub ProcessFeatureQuantityProduct
   dim quanarray, quanlimit, checkname, quantity, featureid
   dim totalnewprice, newprice, tempname, totalnewquantity
   dim tempmsg
   QuanArray = split(featurevalue, ",", -1, 1)
   Quanlimit = ubound(Quanarray)
   totalnewprice = 0
   totalnewquantity = 0
   quantityproducts = ""
   for i = 0 to quanlimit
      featureid = quanarray(i)
      checkname = fprefix & Prodi & "FeatureQuantity" & sOptionNumber & "_" & featureid
      quantity = request(checkname)
      Validatefeaturequantity quantity, rc
      if rc = 0 then
         if quantityproducts<>"" then
            quantityproducts = quantityproducts & ";"
         end if
         quantityproducts = quantityproducts & featureid & "," & quantity
      end if
   next
   if quantityproducts<>"" then
      SetSess "quantityproducts", quantityproducts
   else
      tempmsg = GetLang("LangFeatureMissing") & strcname & " - " & strfeaturecaption & "<br />"
      ShopError tempmsg
   end if
end sub

sub Validatefeaturequantity (quantity, rc)
   dim tquantity
   rc = 4
   if not isnumeric(quantity) then
      quantity = 1
      rc = 0
      exit sub
   end if
   tquantity = clng(quantity)
   if tquantity = 0 then exit sub
   rc = 0
end sub
%>